
Smart Proxy - Bug #36209

tftp initrd/vmlinux generation: curl malformed

03/20/2023 03:19 PM - Sebastian @

Status: Closed   

Priority: Normal   

Assignee: Ewoud Kohl van Wijngaarden   

Category: TFTP   

Target version: 3.6.1   

Difficulty:  Fixed in Releases: 3.5.3, 3.6.1, 3.7.0

Triaged: Yes Found in Releases: 3.5.2, 3.6.0

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/smart-pro

xy/pull/861,

https://github.com/theforeman/smart-pro

xy/pull/862,

https://github.com/theforeman/smart-pro

xy/pull/863

  

Description

Problem:

The TFTP copying of vmlinux and initrd fails with "url malformed".

The Target URL itself is validated muliple times with curl and wget manually, so the file is really downloadable. The source is an

extracted OL8full ISO to /var/www/html/pub on the same foreman/katello host. Please see attached LOG File.

Expected outcome:

vmlinux and initrd are put into /var/lib/tftp/boot

Foreman and Proxy versions:

Foreman: 3.5.2

Katello: 4.7.3

Foreman and Proxy plugin versions:

Distribution and version:

OracleLinux 8.7

Other relevant data:

/var/log/foreman-proxy/proxy.log

2023-03-20T09:19:01 3543f6af [I] Finished POST /tftp/fetch_boot_file with 200 (0.67 ms)

2023-03-20T09:19:01 3543f6af [I] [1164514] Started task /usr/bin/curl\ --silent\ --show-error\ --c

onnect-timeout\ 10\ --retry\ 3\ --retry-delay\ 10\ --max-time\ 3600\ --remote-time\ --time-cond\ f

ile\ /var/lib/tftpboot/boot/oraclelinux-8-iso-local-7jET8gzdRF9B-vmlinuz\ --write-out\ Task\ done,

\ result:\ \%\{http_code\},\ size\ downloaded:\ \%\{size_download\}b,\ speed:\ \%\{speed_download\

}b/s,\ time:\ \%\{time_total\}ms\ --output\ /var/lib/tftpboot/boot/oraclelinux-8-iso-local-7jET8gz

dRF9B-vmlinuz\ --location\ http://katello.test.tools/pub/OracleLinux8_ISO/BaseOS/images/pxeboot/vm

linuz

2023-03-20T09:19:01 3543f6af [I] Started POST /tftp/fetch_boot_file

2023-03-20T09:19:01 3543f6af [I] Finished POST /tftp/fetch_boot_file with 200 (1.68 ms)

2023-03-20T09:19:01 3543f6af [I] [1164518] Started task /usr/bin/curl\ --silent\ --show-error\ --c

onnect-timeout\ 10\ --retry\ 3\ --retry-delay\ 10\ --max-time\ 3600\ --remote-time\ --time-cond\ f

ile\ /var/lib/tftpboot/boot/oraclelinux-8-iso-local-7jET8gzdRF9B-initrd.img\ --write-out\ Task\ do

ne,\ result:\ \%\{http_code\},\ size\ downloaded:\ \%\{size_download\}b,\ speed:\ \%\{speed_downlo

ad\}b/s,\ time:\ \%\{time_total\}ms\ --output\ /var/lib/tftpboot/boot/oraclelinux-8-iso-local-7jET

8gzdRF9B-initrd.img\ --location\ http://katello.test.tools/pub/OracleLinux8_ISO/BaseOS/images/pxeb

oot/initrd.img

2023-03-20T09:19:01 3543f6af [W] [1164514] curl: (3) <url> malformed

2023-03-20T09:19:02 3543f6af [W] [1164518] curl: (3) <url> malformed
 I believe https://projects.theforeman.org/issues/36138 introduced a new bug. If i remove the "file" part from --time-cond the download

works as before.

related forum discussion with further information: 

https://community.theforeman.org/t/curl-url-malformed-during-initrd-and-vmlinux-tftp-copy/32850

Related issues:

Related to Smart Proxy - Bug #36138: Invalid syntax for curl --time-cond Closed

Associated revisions

Revision 90d7cc85 - 03/23/2023 07:12 PM - Leos Stejskal

Fixes #36209 - tftp initrd/vmlinux generation: curl malformed

PR #856 was fixing invalid curl --time-cont condition,

but it actually break it and now files are not downloaded at all.

This reverts commit fba49ab1eb9bbe383572575309558ff628f5de60.

History

#1 - 03/21/2023 09:18 PM - Oliver Freyermuth

- Found in Releases 3.5.2, 3.6.0 added

I can also confirm that this is broken in 3.5.2 and 3.6.0, no new vmlinux / initrd can be downloaded anymore unless the patch is reverted.

I have added this comment to add the corresponding "Found in Releases" to highlight the affected versions, and I have also commented on 

https://projects.theforeman.org/issues/36138 linking to this report to increase visibility.

#2 - 03/22/2023 05:04 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/861 added

#3 - 03/22/2023 04:36 PM - Ewoud Kohl van Wijngaarden

- Related to Bug #36138: Invalid syntax for curl --time-cond added

#4 - 03/22/2023 04:37 PM - Ewoud Kohl van Wijngaarden

- Target version set to 3.6.1

- Triaged changed from No to Yes

Thanks for reporting. For now I'm setting 3.6.1, but should also be included in 3.5.3.

#5 - 03/23/2023 07:12 PM - The Foreman Bot

- Fixed in Releases 3.7.0 added

#6 - 03/23/2023 07:14 PM - The Foreman Bot

- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/smart-proxy/pull/862 added

#7 - 03/23/2023 07:15 PM - The Foreman Bot

- Pull request https://github.com/theforeman/smart-proxy/pull/863 added

#8 - 03/23/2023 07:18 PM - The Foreman Bot

- Fixed in Releases 3.6.1 added

#9 - 03/23/2023 07:19 PM - The Foreman Bot

- Fixed in Releases 3.5.3 added

#10 - 03/23/2023 08:01 PM - Leos Stejskal

- Status changed from Ready For Testing to Closed

Applied in changeset 90d7cc850993a950edb760d8badcbace09c3a34a.
